package org.nakedobjects.nof.reflect.java.annotations;

import java.lang.reflect.Method;

import org.nakedobjects.noa.annotations.Annotation;


public interface AnnotationFactory {

    Class getAnnotationType();

    /**
     * Process the class, and return the correctly setup annotation if present.
     */
    Annotation process(Class clazz);

    /**
     * Process the method, and return the correctly setup annotation if present.
     */
    Annotation process(Method method);

    /**
     * Process the parameters of the method, and return the correctly setup annotation if present.
     * 
     * @param n -
     *            0-based index to the parameter to be processed.
     */
    Annotation processParams(Method method, int n);

}
