package org.nakedobjects.nof.reflect.java.annotations;



public class DefaultAnnotationFactorySet extends AbstractAnnotationFactorySet {

    public DefaultAnnotationFactorySet() {
        registerFactory(new NamedAnnotationFactory());
        registerFactory(new PluralAnnotationFactory());
        registerFactory(new DescribedAsAnnotationFactory());

        registerFactory(new OptionalAnnotationFactory());
        registerFactory(new MandatorySemanticFactory()); // corollary of Optional; enforces Constraints

        registerFactory(new DisabledAnnotationFactory());
        registerFactory(new ImmutableAnnotationFactory());
        registerFactory(new NotPersistedAnnotationFactory());
        registerFactory(new NotPersistableAnnotationFactory());
        registerFactory(new HiddenAnnotationFactory());

        registerFactory(new BoundedAnnotationFactory());

        registerFactory(new ExecutedAnnotationFactory());
        registerFactory(new DebugAnnotationFactory());
        registerFactory(new ExplorationAnnotationFactory());

        registerFactory(new MaxLengthAnnotationFactory());
        registerFactory(new TypicalLengthAnnotationFactory());

        registerFactory(new MultiLineAnnotationFactory());
        registerFactory(new RegExAnnotationFactory());
        registerFactory(new MaskAnnotationFactory());

        registerFactory(new MemberOrderAnnotationFactory());
        registerFactory(new ActionOrderAnnotationFactory());
        registerFactory(new FieldOrderAnnotationFactory());

        registerFactory(new TypeOfAnnotationFactory());
        registerFactory(new ValueAnnotationFactory());

        // REVIEW this factory replaces the one above as it also provide NamedAnnotation objects; we need to
        // be able to have more that one factory for any specific type
        // registerFactory(new NamedAnnotationFactory2());
    }

}
