package org.nakedobjects.nof.reflect.java.annotations;

import java.lang.reflect.Method;

import org.nakedobjects.applib.annotation.DescribedAs;
import org.nakedobjects.noa.annotations.Annotation;
import org.nakedobjects.noa.annotations.DescribedAsAnnotation;


public class DescribedAsAnnotationFactory extends AbstractAnnotationFactory {

    public DescribedAsAnnotationFactory() {
        super(DescribedAsAnnotation.class);
    }

    public Annotation process(final Class cls) {
        DescribedAs annotation = (DescribedAs) cls.getAnnotation(DescribedAs.class);
        return create(annotation);
    }

    public Annotation process(final Method method) {
        DescribedAs annotation = (DescribedAs) method.getAnnotation(DescribedAs.class);
        return create(annotation);
    }

    public Annotation processParams(Method method, int paramNum) {

        java.lang.annotation.Annotation[] parameterAnnotations = method.getParameterAnnotations()[paramNum];

        for (int j = 0; j < parameterAnnotations.length; j++) {
            if (parameterAnnotations[j] instanceof DescribedAs) {
                return create((DescribedAs) parameterAnnotations[j]);
            }
        }

        return null;
    }

    private DescribedAsAnnotation create(DescribedAs annotation) {
        return annotation == null ? null : new DescribedAsAnnotation(annotation.value());
    }

}
