package org.nakedobjects.nof.reflect.java.annotations;

import java.lang.reflect.Method;

import org.nakedobjects.applib.annotation.Disabled;
import org.nakedobjects.noa.annotations.Annotation;
import org.nakedobjects.noa.annotations.DisabledAnnotation;


public class DisabledAnnotationFactory extends AbstractAnnotationFactory {

    public DisabledAnnotationFactory() {
        super(DisabledAnnotation.class);
    }

    public Annotation process(final Method method) {
        Disabled annotation = (Disabled) method.getAnnotation(Disabled.class);
        return create(annotation);
    }

    private DisabledAnnotation create(Disabled annotation) {
        return annotation == null ? null : new DisabledAnnotation(decodeWhen(annotation.value()));
    }

}
