package org.nakedobjects.nof.reflect.java.annotations;

import java.lang.reflect.Method;

import org.nakedobjects.applib.annotation.Executed;
import org.nakedobjects.noa.annotations.Annotation;
import org.nakedobjects.noa.annotations.ExecutedAnnotation;


public class ExecutedAnnotationFactory extends AbstractAnnotationFactory {

    public ExecutedAnnotationFactory() {
        super(ExecutedAnnotation.class);
    }

    public Annotation process(final Method method) {
        Executed annotation = (Executed) method.getAnnotation(Executed.class);
        return create(annotation);
    }

    private ExecutedAnnotation create(Executed annotation) {
        return annotation == null ? null : new ExecutedAnnotation(decodeWhere(annotation.value()));
    }

    protected org.nakedobjects.noa.annotations.ExecutedAnnotation.Where decodeWhere(Executed.Where where) {
        if (where == Executed.Where.LOCALLY) {
            return org.nakedobjects.noa.annotations.ExecutedAnnotation.Where.LOCALLY;
        }
        if (where == Executed.Where.REMOTELY) {
            return org.nakedobjects.noa.annotations.ExecutedAnnotation.Where.REMOTELY;
        }
        return null;
    }

}
