package org.nakedobjects.nof.reflect.java.annotations;

import java.lang.reflect.Method;

import org.nakedobjects.applib.annotation.Mask;
import org.nakedobjects.noa.annotations.Annotation;
import org.nakedobjects.noa.annotations.MaskAnnotation;


public class MaskAnnotationFactory extends AbstractAnnotationFactory {

    public MaskAnnotationFactory() {
        super(MaskAnnotation.class);
    }

    /**
     * In readiness for supporting <tt>@Value</tt> in the future.
     */
    public Annotation process(Class clazz) {
        Mask annotation = (Mask) clazz.getAnnotation(Mask.class);
        return create(annotation);
    }

    public Annotation process(final Method method) {
        Mask annotation = (Mask) method.getAnnotation(Mask.class);
        return create(annotation);
    }

    public Annotation processParams(Method method, int paramNum) {

        java.lang.annotation.Annotation[] parameterAnnotations = method.getParameterAnnotations()[paramNum];
        for (int j = 0; j < parameterAnnotations.length; j++) {
            if (parameterAnnotations[j] instanceof Mask) {
                return create((Mask) parameterAnnotations[j]);
            }
        }
        return null;
    }

    private MaskAnnotation create(Mask annotation) {
        if (annotation == null) {
            return null;
        }
        return new MaskAnnotation(annotation.value());
    }

}
