package org.nakedobjects.nof.reflect.java.annotations;

import java.lang.reflect.Method;

import org.nakedobjects.applib.annotation.MultiLine;
import org.nakedobjects.noa.annotations.Annotation;
import org.nakedobjects.noa.annotations.MultiLineAnnotation;


public class MultiLineAnnotationFactory extends AbstractAnnotationFactory {

    public MultiLineAnnotationFactory() {
        super(MultiLineAnnotation.class);
    }

    /**
     * In readiness for supporting <tt>@Value</tt> in the future.
     */
    public Annotation process(Class clazz) {
        MultiLine annotation = (MultiLine) clazz.getAnnotation(MultiLine.class);
        return create(annotation);
    }

    public Annotation process(final Method method) {
        MultiLine annotation = (MultiLine) method.getAnnotation(MultiLine.class);
        return create(annotation);
    }

    public Annotation processParams(Method method, int paramNum) {

        java.lang.annotation.Annotation[] parameterAnnotations = method.getParameterAnnotations()[paramNum];

        for (int j = 0; j < parameterAnnotations.length; j++) {
            if (parameterAnnotations[j] instanceof MultiLine) {
                return create((MultiLine) parameterAnnotations[j]);
            }
        }

        return null;
    }

    private MultiLineAnnotation create(MultiLine annotation) {
        if (annotation == null) {
            return null;
        }
        return new MultiLineAnnotation(annotation.numberOfLines(), annotation.preventWrapping());
    }

}
