package org.nakedobjects.nof.reflect.java.annotations;

import java.lang.reflect.Method;

import org.nakedobjects.applib.annotation.NotPersisted;
import org.nakedobjects.noa.annotations.Annotation;
import org.nakedobjects.noa.annotations.NotPersistedAnnotation;


public class NotPersistedAnnotationFactory extends AbstractAnnotationFactory {

    public NotPersistedAnnotationFactory() {
        super(NotPersistedAnnotation.class);
    }

    public Annotation process(final Class clazz) {
        NotPersisted annotation = (NotPersisted) clazz.getAnnotation(NotPersisted.class);
        return create(annotation);
    }

    public Annotation process(final Method method) {
        NotPersisted annotation = (NotPersisted) method.getAnnotation(NotPersisted.class);
        return create(annotation);
    }

    private NotPersistedAnnotation create(NotPersisted annotation) {
        return annotation == null ? null : new NotPersistedAnnotation();
    }

}
