package org.nakedobjects.nof.reflect.java.annotations;

import java.lang.reflect.Method;

import org.nakedobjects.applib.annotation.TypicalLength;
import org.nakedobjects.noa.annotations.Annotation;
import org.nakedobjects.noa.annotations.TypicalLengthAnnotation;


public class TypicalLengthAnnotationFactory extends AbstractAnnotationFactory {

    public TypicalLengthAnnotationFactory() {
        super(TypicalLengthAnnotation.class);
    }

    /**
     * In readiness for supporting <tt>@Value</tt> in the future.
     */
    public Annotation process(Class clazz) {
        TypicalLength annotation = (TypicalLength) clazz.getAnnotation(TypicalLength.class);
        return annotation == null ? null : new TypicalLengthAnnotation(annotation.value());
    }

    public Annotation process(final Method method) {
        TypicalLength annotation = (TypicalLength) method.getAnnotation(TypicalLength.class);
        return annotation == null ? null : new TypicalLengthAnnotation(annotation.value());
    }

    public Annotation processParams(Method method, int paramNum) {

        java.lang.annotation.Annotation[] parameterAnnotations = method.getParameterAnnotations()[paramNum];

        for (int j = 0; j < parameterAnnotations.length; j++) {
            if (parameterAnnotations[j] instanceof TypicalLength) {
                TypicalLength named = (TypicalLength) parameterAnnotations[j];
                return new TypicalLengthAnnotation(named.value());
            }
        }

        return null;
    }

}
