package org.nakedobjects.nof.reflect.java.annotations2;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

import org.nakedobjects.noa.NakedObjectRuntimeException;
import org.nakedobjects.noa.annotations.Annotation;
import org.nakedobjects.noa.annotations.NamedAnnotation;
import org.nakedobjects.nof.reflect.java.annotations.AbstractAnnotationFactory;


public class NamedAnnotationFactory2 extends AbstractAnnotationFactory {

    public NamedAnnotationFactory2() {
        super(NamedAnnotation.class);
    }

    public Annotation process(final Class clazz) {
        Method annotation;
        try {
            annotation = clazz.getMethod("name", new Class[0]);
        } catch (SecurityException e) {
            throw new NakedObjectRuntimeException(e);
        } catch (NoSuchMethodException e) {
            return null;
        }
        return create(annotation);
    }

    public Annotation process(final Method method) {
        Class clazz = method.getDeclaringClass();
        String name = method.getName().substring(3);
        Method annotation;
        try {
            annotation = clazz.getMethod("name" + name, new Class[0]);
        } catch (SecurityException e) {
            throw new NakedObjectRuntimeException(e);
        } catch (NoSuchMethodException e) {
            return null;
        }
        return create(annotation);
    }

    public Annotation processParams(Method method, int paramNum) {
        return null;

        /*
         java.lang.annotation.Annotation[] parameterAnnotations = method.getParameterAnnotations()[paramNum];

        for (int j = 0; j < parameterAnnotations.length; j++) {
            if (parameterAnnotations[j] instanceof Named) {
                return create((Named) parameterAnnotations[j]);
            }
        }
        return null;
        */
    }

    private NamedAnnotation create(final Method annotation) {
        if (annotation == null) {
            return null;
        }
        
        String name;
        try {
            name = (String) annotation.invoke(null, new Object[0]);
        } catch (IllegalArgumentException e) {
            throw new NakedObjectRuntimeException(e);
        } catch (IllegalAccessException e) {
            throw new NakedObjectRuntimeException(e);
        } catch (InvocationTargetException e) {
            throw new NakedObjectRuntimeException(e);
        }
        return new NamedAnnotation(name);
    }

}
