package org.nakedobjects.nof.reflect.java.collection;

import java.util.Enumeration;

import org.nakedobjects.noa.adapter.NakedObject;
import org.nakedobjects.noa.spec.NakedObjectSpecification;


public class ArrayAdapter extends AbstractCollectionAdapter {
    private Object[] array;

    public ArrayAdapter(final Object[] array, final NakedObjectSpecification spec) {
        super(spec);
        this.array = array;
    }

    public boolean contains(final NakedObject object) {
        for (int i = 0; i < array.length; i++) {
            if (array[i] == object.getObject()) {
                return true;
            }
        }
        return false;
    }

    public Enumeration elements() {
        return new Enumeration() {
            int count = 0;

            public boolean hasMoreElements() {
                return count < array.length;
            }

            public Object nextElement() {
                return adapter(array[count++]);
            }
        };
    }

    public NakedObject firstElement() {
        return array.length > 0 ? (NakedObject) adapter(array[0]) : null;
    }

    public Object getObject() {
        return array;
    }

    public void init(final Object[] elements) {
        int size = elements.length;
        array = new Object[size];
        for (int i = 0; i < size; i++) {
            array[i] = elements[i];
        }
    }

    public int size() {
        return array.length;
    }

    protected String toStringElements() {
        return array.toString();
    }
}
// Copyright (c) Naked Objects Group Ltd.
