package org.nakedobjects.nof.reflect.java.collection;

import java.util.Enumeration;

import org.nakedobjects.noa.adapter.NakedObject;
import org.nakedobjects.noa.spec.NakedCollectionSpecification;
import org.nakedobjects.noa.spec.NakedObjectSpecification;

public class ArrayCollectionSpecification extends AbstractCollectionSpecification implements NakedCollectionSpecification {

    public ArrayCollectionSpecification(String className, NakedObjectSpecification elementClass) {
        super(className, elementClass);
    }

    public boolean contains(final NakedObject collection, final NakedObject object) {
        Object[] array = (Object[]) collection.getObject();
        for (int i = 0; i < array.length; i++) {
            if (array[i] == object.getObject()) {
                return true;
            }
        }
        return false;
    }

    public Enumeration elements(final NakedObject collection) {
        final Object[] array = (Object[]) collection.getObject();

        return new Enumeration() {
            int count = 0;

            public boolean hasMoreElements() {
                return count < array.length;
            }

            public Object nextElement() {
                return adapter(array[count++]);
            }
        };
    }

    public NakedObject firstElement(final NakedObject collection) {
        final Object[] array = (Object[]) collection.getObject();
        return array.length > 0 ? (NakedObject) adapter(array[0]) : null;
    }

    public void init(final NakedObject collection, final Object[] elements) {
        Object[] array = (Object[]) collection.getObject();
        int size = elements.length;
        array = new Object[size];
        for (int i = 0; i < size; i++) {
            array[i] = elements[i];
        }
    }

    public int size(final NakedObject collection) {
        final Object[] array = (Object[]) collection.getObject();
        return array.length;
    }
}


// Copyright (c) Naked Objects Group Ltd.
