package org.nakedobjects.nof.reflect.java.collection;

import java.util.Enumeration;
import java.util.Vector;

import org.nakedobjects.noa.adapter.NakedObject;
import org.nakedobjects.noa.spec.NakedObjectSpecification;
import org.nakedobjects.nof.core.util.Assert;


public class VectorCollectionAdapter extends AbstractCollectionAdapter {
    private final Vector collection;

    public VectorCollectionAdapter(final Vector vector, final NakedObjectSpecification spec) {
    	super(spec);
        Assert.assertNotNull("Vector", vector);
        Assert.assertNotNull("Element specification", spec);
        this.collection = vector;
    }

    public boolean contains(final NakedObject object) {
        return collection.contains(object.getObject());
    }

    public Enumeration elements() {
        final Enumeration elements = collection.elements();

        return new Enumeration() {
            public boolean hasMoreElements() {
                return elements.hasMoreElements();
            }

            public Object nextElement() {
                Object element = elements.nextElement();
                return adapter(element);
            }
        };
    }

    public NakedObject firstElement() {
        if (size() == 0) {
            return null;
        } else {
            Object element = collection.get(0);
            return adapter(element);
        }
    }

    public Object getObject() {
        return collection;
    }

    public void init(final Object[] initElements) {
        Assert.assertEquals("Collection not empty", 0, this.collection.size());
        for (int i = 0; i < initElements.length; i++) {
            collection.addElement(initElements[i]);
        }
    }

    public int size() {
        return collection.size();
    }
    
    protected String toStringElements() {
    	return "" + collection.size();
    }
}
// Copyright (c) Naked Objects Group Ltd.
