package org.nakedobjects.nof.reflect.java.reflect;

import java.lang.reflect.Method;

import org.nakedobjects.nof.reflect.peer.MemberIdentifier;


class ArrayStrategy extends AbstractOneToManyStrategy {

    protected ExtensionHolderMutableFieldPeer createPeer(
            final MemberIdentifier identifier,
            final Class elementType,
            final DescriptiveMethods descriptiveMethods,
            final FieldMethods fieldMethods,
            final GeneralControlMethods controlMethods,
            final FieldFlags fieldFlags,
            final MemberSessionMethods sessionMethods,
            final Method clearMethod) {
        final JavaArray javaOneToManyAssociation = new JavaArray(identifier, elementType, descriptiveMethods, fieldMethods, controlMethods,
                                fieldFlags, clearMethod, sessionMethods);
        
        return javaOneToManyAssociation;
    }

    protected Class getElementType(Method getMethod, Class aboutType, Class removeType, Class addType) {
        return getMethod.getReturnType().getComponentType();
    }

    public Class getReturnType() {
        return Object[].class;
    }
}
// Copyright (c) Naked Objects Group Ltd.
