package org.nakedobjects.nof.reflect.java.reflect;

import org.nakedobjects.noa.spec.ExtensionHolder;
import org.nakedobjects.noa.spec.NakedObjectSpecification;

/**
 * Subinterface of {@link ExtensionHolder} implemented by all concrete
 * instances of {@link NakedObjectSpecification}, allowing extensions to be
 * added.
 * 
 * <p>
 * This is used by the {@link JavaIntrospector}.
 */
public interface ExtensionHolderMutable extends ExtensionHolder {

    /**
     * Adds the extension, using its class as the key.
     * 
     * <p>
     * If there are any extensions of the same class, they will be
     * overwritten.
     */
    void addExtension(Object extension);

    
}
