package org.nakedobjects.nof.reflect.java.reflect;

import java.util.HashMap;
import java.util.Map;

import org.nakedobjects.noa.annotations.DescribedAsAnnotation;
import org.nakedobjects.noa.annotations.NamedAnnotation;
import org.nakedobjects.noa.spec.NakedObjectSpecification;

public class JavaActionParam implements ExtensionHolderMutableActionParamPeer {

    private Map extensionsByClass = new HashMap();
    public JavaActionParam(
            NakedObjectSpecification specification) {
        this.specification = specification;
    }
    
    private final NakedObjectSpecification specification;
    public NakedObjectSpecification getSpecification() {
        return specification;
    }
    
    ////////////////////// Common ////////////////////////
    
    public String getName() {
        return (String) getExtension(NamedAnnotation.class);
    }
    
    public String getDescription() {
        return (String) getExtension(DescribedAsAnnotation.class);
    }
    
    ////////////////////// Extensions ////////////////////
    public Object getExtension(Class cls) {
        return extensionsByClass.get(cls);
    }
    public Class[] getExtensions() {
        return (Class[]) extensionsByClass.keySet().toArray(new Class[]{});
    }
    
    public void addExtension(Object extension) {
        extensionsByClass.put(extension.getClass(), extension);
    }
    

}
