package org.nakedobjects.nof.reflect.java.reflect;

import java.lang.reflect.Method;

import org.nakedobjects.noa.adapter.NakedObject;
import org.nakedobjects.noa.reflect.Consent;
import org.nakedobjects.nof.core.reflect.Veto;
import org.nakedobjects.nof.core.util.UnexpectedCallException;
import org.nakedobjects.nof.reflect.peer.MemberIdentifier;


public class JavaArray extends AbstractJavaCollectionField {

    public JavaArray(
            final MemberIdentifier name,
            final Class type,
            final DescriptiveMethods descriptiveMethods,
            final FieldMethods fieldMethods,
            final GeneralControlMethods controlMethods,
            final FieldFlags fieldFlags,
            final Method clearMethod,
            final MemberSessionMethods sessionMethods) {
        super(name, type, descriptiveMethods, fieldMethods, controlMethods, fieldFlags, clearMethod, sessionMethods);
    }
    
    public Consent isAddValid(final NakedObject container, final NakedObject element) {
        return new Veto("Elements cannot be added to arrays");
    }

    protected void add(Object collection, Object element) {
        throw new UnexpectedCallException();
    }
    /*
    public void initOneToManyAssociation(NakedObject fromObject, NakedObject[] instances) {
        super.initOneToManyAssociation(fromObject, instances);
    }
    */
    protected void init(Object collection, Object[] elements) {
        Object[] array = (Object[]) collection;
        for (int i = 0; i < array.length && i < elements.length; i++) {
            array[i] = elements[i];
        }
        // TODO need to set field 
    //    setMethod.invoke(obj, args)
    }

    protected void clear(Object collection) {
    }

    protected boolean isEmpty(Object collection) {
        Object[] array = (Object[]) collection;
        return array.length == 0;
    }

    public void removeAllAssociations(NakedObject inObject) {
        throw new UnexpectedCallException();
    }
    
    protected void removeElement(Object collection, Object element) {
        throw new UnexpectedCallException();
    }
}
// Copyright (c) Naked Objects Group Ltd.
