package org.nakedobjects.nof.reflect.java.reflect;

import java.util.regex.Pattern;

import org.nakedobjects.noa.adapter.FieldRegEx;
import org.nakedobjects.nof.core.adapter.value.RegExProcessor;

public class JavaRegEx extends RegExProcessor {

    
    protected String format(FieldRegEx regEx, String text) {
        Pattern pattern = Pattern.compile(regEx.getValidationExpression(), !regEx.isCaseSensitive() ? Pattern.CASE_INSENSITIVE : 0);
        return pattern.matcher(text).replaceAll(regEx.getFormatExpression());
    }

    
    protected boolean isValid(FieldRegEx regEx, String text) {
        Pattern pattern = Pattern.compile(regEx.getValidationExpression(), !regEx.isCaseSensitive() ? Pattern.CASE_INSENSITIVE : 0);
        return pattern.matcher(text).matches();
    }
}


// Copyright (c) Naked Objects Group Ltd.
