package org.nakedobjects.nof.reflect.java.reflect;

import java.lang.reflect.Method;

public class MethodPattern {

    private final String name;
    private final Class[] parameterTypes;
    private final Method method;

    public MethodPattern(Method method, String name, Class returnType) {
        this.method = method;
        this.name = name;
        parameterTypes = new Class[] { returnType };
    }

    public MethodPattern(Method method, String name, Class[] parameterTypes) {
        this.method = method;
        this.name = name;
        this.parameterTypes = parameterTypes;
    }

    public String getName() {
        return name;
    }
    
    public Method getMethod() {
        return method;
    }

    public Class[] getParameterTypes() {
        return parameterTypes;
    }

}

// Copyright (c) Naked Objects Group Ltd.
