package org.nakedobjects.nof.reflect.java.value;

import org.nakedobjects.applib.value.Password;
import org.nakedobjects.noa.adapter.value.PasswordValue;
import org.nakedobjects.nof.core.adapter.value.AbstractValueAdapter;


public class PasswordAdapter extends AbstractValueAdapter implements PasswordValue {
    Password password;

    public PasswordAdapter() {}

    public PasswordAdapter(Password password) {
        this.password = password;
    }

    protected String doEncode() {
        return password.getPassword();
    }

    public boolean canClear() {
        return true;
    }

    public boolean checkPassword(String password) {
        return this.password.checkPassword(password);
    }

    public void clear() {
        password = null;
    }

    public String getIconName() {
        return "password";
    }

    public Object getObject() {
        return password;
    }
    
    public String getEditText() {
        return isEmpty() ? "" : password.getPassword();
    }

    public Class getValueClass() {
        return Password.class;
    }

    public boolean isEmpty() {
        return password == null || password.checkPassword("");
    }

    protected void doParse(String text) {
            password = new Password(text);
    }

    protected void doRestore(String data) {
            password = new Password(data);
    }

    public void setMask(String mask) {}

    public void setValue(String password) {
        this.password = new Password(password);
    }

    public String titleString() {
        return password == null ? "" : password.toString();
    }

    public String toString() {
        return "PasswordAdapter: " + password;
    }

}

// Copyright (c) Naked Objects Group Ltd.
